package bg.bas.dcl.general;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import org.apache.http.HeaderElement;
import org.apache.http.HeaderElementIterator;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeaderElementIterator;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import bg.bas.dcl.general.FileHandler;

public class TextProcessor {
	
	String resourcePathSent = "/home/ivelina/DCLTools/trunk/resources/en-sent.bin";
	String resourcePathTokens = "/home/ivelina/DCLTools/trunk/resources/en-token.bin";
	InputStream modelSent = null;
	
	public final static String[] services = {"tokenizer", "tagger", "lematizer"};
	public final static int Tokenizer = 0, Tagger = 1, Lematizer = 2;
	public final static String token = "619e68bffedc7243fe6b82822987432d";

	public TextProcessor(){

	}
	
	public static String applyServiceToText(String text, int service) {
		
		if (text.equals("")) return "";
		
		
    	String URL = "http://dcl.bas.bg/dclservices/service/bglpc/"
    			+ services[service] + "/text/";
    	
    	
    	
    	HttpClient httpclient = new DefaultHttpClient();
    	
    	try {
    			                
 
    		List<NameValuePair> formparams = new ArrayList<NameValuePair>();

    		formparams.add(new BasicNameValuePair("text", text));
       		formparams.add(new BasicNameValuePair("token", token));
     		formparams.add(new BasicNameValuePair("submit", "submit"));
    		
    		UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
    		
    		HttpPost httppost = new HttpPost();
    		httppost.setEntity(entity);
    		httppost.setURI(new URI(URL));
    		

    		HttpResponse response = httpclient.execute(httppost);

    		HttpEntity myEntity = response.getEntity();
     		
    		String result = EntityUtils.toString(myEntity);
  
    		httppost.abort();
    		
    		
    		return result;
    		
    	} catch(Exception e)  {
    		e.printStackTrace();

    	}
    			            
    	return null;
	}
	


}

