package bg.bas.dcl.inflection.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;

//import org.json.simple.JSONObject;


import bg.bas.dcl.MWE.MWEComponent;
import bg.bas.dcl.MWE.MWEProcessor;
//import bg.bas.dcl.general.JSONProcessor;
import bg.bas.dcl.inflection.FlectionModel;
import bg.bas.dcl.inflection.Form;
import bg.bas.dcl.inflection.InitialParametersReader;

public class InflectionTypeConstructorGUI {
	
	JFrame frame;
    Container container;
    
    String typesfile="";
     String exfile="";
     
   JList<String> examplebox ;
   JScrollPane scroll_EB ;
    
    MWEProcessor processor = new MWEProcessor();

    public InflectionTypeConstructorGUI(){
    	
     	
    }

    JCheckBox other = new JCheckBox("Друг тип !");
    JCheckBox aspect = new JCheckBox("Другият вид е валиден +");
    JCheckBox external = new JCheckBox("Външни |");
     JCheckBox modifx = new JCheckBox("XP модификатор /");
   JCheckBox modif = new JCheckBox("NP модификатор @");
   JCheckBox vorderx = new JCheckBox("Само XP_V ^");
     JCheckBox vorder = new JCheckBox("Само V_XP %");
    JCheckBox fixed = new JCheckBox("_XP неизм. ?");
   JCheckBox onlydef = new JCheckBox("Само чл. £");
   JCheckBox nodef = new JCheckBox("Само нечл. $");
  JCheckBox nosing = new JCheckBox("Само мн.ч. ~");
   JCheckBox noplural = new JCheckBox("Само ед.ч. #");
   JCheckBox NE = new JCheckBox("Именувана същност &");
   JCheckBox error = new JCheckBox("Невалидна единица *");
   
   JTextArea selectedtypebox = new JTextArea();
   JList<String> typebox ; 

   
   public void renewTypeList(String typetype) {
    	  
	   for (int i = 0; i<typeslist.size();i++){
		   String element = typeslist.get(i);
		   
    		   if (tmodel.contains(element) &&
    				   !(element.startsWith("N") && element.contains("M") && typetype.contains("NP_M"))
    			  		&& !(element.startsWith("N") && element.contains("F") && typetype.contains("NP_F"))
    			  		&& !(element.startsWith("N") && element.substring(1).contains("N") && typetype.contains("NP_N"))
    			  		&& !(element.startsWith("N") && !element.contains("M") && !element.contains("F") && !element.substring(1).contains("N") && typetype.contains("NP_0"))
    			  		&& !(element.startsWith("V") && typetype.contains("VP"))
    			  		&& !(element.startsWith("V") && typetype.contains("VP"))
     				   )
    			   tmodel.remove(tmodel.indexOf(element));
    		   if (!tmodel.contains(element) &&
    				  ((element.startsWith("N") && element.contains("M") && typetype.contains("NP_M"))
    			  		||(element.startsWith("N") && element.contains("F") && typetype.contains("NP_F"))
    			  		||(element.startsWith("N") && element.substring(1).contains("N") && typetype.contains("NP_N"))
    			  		||(element.startsWith("N") && !element.contains("M") && !element.contains("F") && !element.substring(1).contains("N") && typetype.contains("NP_0"))
    			  		||(element.startsWith("V") && typetype.contains("VP"))
    			  		||(element.startsWith("V") && typetype.contains("VP"))
     				   ))
    			   tmodel.add(0,element);
    		   if (!tmodel.contains(element) &&
     				  typetype.equals("All"))
     			   tmodel.add(0,element);
	  
	   }
    	   

    }
	
	 DefaultListModel<String> tmodel = 
 			new DefaultListModel<String>();
 	 DefaultListModel<String> emodel = 
 			new DefaultListModel<String>();
     ArrayList<String> exampleslist ;
     ArrayList<String> typeslist ;

    public void setup( final String typesfile,  final String exfile){
    	
    	 this.typesfile = typesfile;
    	 this.exfile = exfile;
    	 
       	  // main frame
      frame = new JFrame("Inflector " + exfile);
      container = frame.getContentPane();

      container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));
  	
      frame.addWindowListener(
    		    new WindowAdapter() {
    		        public void windowClosing(WindowEvent e) {
    		            exit();
    		        }
    		    }
      );
      frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
      frame.setJMenuBar(setupMenu());



  	JPanel typePanel = new JPanel();
  	typePanel.setLayout(new BoxLayout(typePanel, BoxLayout.Y_AXIS));
	
  	JLabel tlabel = new JLabel("Избери флективен тип:");
  	
  	String[] typeStrings = { "NP_M", "NP_N", "NP_F", "NP_0", 
  			"VP_NP", "VP_PP", "VP_AdjP", "VP_AdvP", "VP", "All" };

    exampleslist
 		= InitialParametersReader.readListFromFile(exfile);
     typeslist
 		= InitialParametersReader.readListFromFile(typesfile);

  	Collections.sort(typeslist);
  	
  //Create the combo box, select item at index 4.
  //Indices start at 0, so 4 specifies the pig.
  JComboBox<String> typetypeList = new JComboBox<String>(typeStrings);
  typetypeList.setSelectedIndex(0);
  typetypeList.addActionListener(new ActionListener(){

	  	@Override
	  public void actionPerformed(ActionEvent e) {
	  		JComboBox<String> cb = (JComboBox)e.getSource();
	  		String newSelection = (String)cb.getSelectedItem();
	  		
	  		System.out.println(newSelection);
	  		
 	  		renewTypeList(newSelection); 
    }
	  
  });
  	
  JPanel typePanel1 = new JPanel();
	typePanel1.add(tlabel);
	typePanel1.add(typetypeList);
	
	typePanel.add(typePanel1);

  	tmodel = new DefaultListModel<String>();
  	typebox = new JList<String>(tmodel);
     
      for (String element : typeslist){
    	  tmodel.addElement(element);
      }
      
      typebox.setSize(400, 100);
      typebox.setBackground(Color.WHITE);
      
      JScrollPane scroll_TB = new JScrollPane (typebox);
       
      scroll_TB.setSize(400, 100);

      
      selectedtypebox.setSize(380, 50);
      selectedtypebox.setLineWrap(true);
      selectedtypebox.setWrapStyleWord(true);
      selectedtypebox.setRows(3);
      selectedtypebox.setColumns(40);
      selectedtypebox.setBackground(Color.WHITE);
      JScrollPane scroll_SFB = new JScrollPane (selectedtypebox);
       
      scroll_SFB.setSize(400, 50);
      

      JPanel buttons = new JPanel();
      
      JButton selectbutton = new JButton("Избери тип ⇩");
      JButton savetypebutton = new JButton("Запиши нов тип ⇧");
      
      buttons.add(selectbutton);
      buttons.add(savetypebutton);
      
      typePanel.add(scroll_TB);
      typePanel.add(buttons);
      typePanel.add(scroll_SFB);

      
 	JPanel exPanel = new JPanel();
	
  	JLabel elabel = new JLabel("Избери единица:");
  	exPanel.add(elabel);

  	emodel = new DefaultListModel<String>();
      examplebox = new JList<String>(emodel);
      
      for (String element : exampleslist){
    	  emodel.addElement(element);
      }

      examplebox.setSize(380, 100);
      examplebox.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
      examplebox.setLayoutOrientation(JList.VERTICAL);
      examplebox.setBackground(Color.WHITE);
      
      
      scroll_EB = new JScrollPane (examplebox);
       
      scroll_EB.setSize(400, 100);

      exPanel.add(scroll_EB);
      
      final JTextArea formsbox = new JTextArea();
      formsbox.setSize(180, 100);
      formsbox.setLineWrap(true);
      formsbox.setWrapStyleWord(true);
      formsbox.setRows(5);
      formsbox.setColumns(30);
      formsbox.setBackground(Color.WHITE);
      JScrollPane scroll_FB = new JScrollPane (formsbox);
       
      scroll_FB.setSize(200, 100);

      
      final JTextArea formsbox1 = new JTextArea("Вид св. <--> несв.");
      formsbox1.setSize(180, 100);
      formsbox1.setLineWrap(true);
      formsbox1.setWrapStyleWord(true);
      formsbox1.setRows(5);
      formsbox1.setColumns(30);
      formsbox1.setBackground(Color.WHITE);
      JScrollPane scroll_FB1 = new JScrollPane (formsbox1);
       
      scroll_FB1.setSize(200, 100);

      
      
      
      JButton button = new JButton("Припиши тип");
      button.addActionListener(new ActionListener() {
//  		comppanel.add(compeditbutton);

          public void actionPerformed(ActionEvent e)
          {
        	  
         	  String exampletext = examplebox.getSelectedValue().toString();
        	  String exdat[] = exampletext.split(",");
        	  String example = exdat[0];
        	  String origtype = exdat[1];
        	  
        	  String type = selectedtypebox.getText();
        	  String typedat[] = type.split("=");
        	  String typename = typedat[0].trim();
        	  String typedef = typedat[1].trim();
  
        	  String newvalue = example + "," + typename;
        	  
        	  int ind = examplebox.getSelectedIndex();
        	  emodel.insertElementAt(newvalue, ind);
        	  emodel.remove(ind+1);
           }
      });
      
      JButton savebutton = new JButton("Запази промените");
      savebutton.addActionListener(new ActionListener() {
//  		comppanel.add(compeditbutton);

          public void actionPerformed(ActionEvent e)
          {
        	  saveAll();
          }
      });

      
      selectbutton.addActionListener(new ActionListener() {
//  		comppanel.add(compeditbutton);

          public void actionPerformed(ActionEvent e)
          {
           	
        	  selectedtypebox.setText(typebox.getSelectedValue().toString());
              	  
        	  
        	  String type = selectedtypebox.getText();
        	  String exampletext = examplebox.getSelectedValue().toString();
        	  String exdat[] = exampletext.split(",");
        	  String example = exdat[0];
        	  String origtype = exdat[1];
        	  
        	  FlectionModel fm = new FlectionModel(type);
        	  ArrayList<Form> forms = fm.generateForms(example);
        	  
        	  String formstext = "";
        	  for (Form f : forms) 
        		  formstext += 
        			  f.form +"," +f.POS+f.tags+ "\n";
        	  formsbox.setText(formstext);

          }
      });

      savetypebutton.addActionListener(new ActionListener() {
//  		comppanel.add(compeditbutton);

          public void actionPerformed(ActionEvent e)
          {
           	
        	  String newtype = selectedtypebox.getText();
        	  String[] newdata = newtype.split("=");
        	  
        	  if (newdata.length<2) {
        		  JOptionPane.showMessageDialog(frame, "Следвайте формата ТИП = дефиниция на формите");
        		  return;
        	  }
        	  
    		  String newtyp = newdata[0].trim();
    		  String newdef = newdata[1].trim();
        	  
        	  Enumeration<String> en = tmodel.elements();
        	  while (en.hasMoreElements()){
        		  String[] data = en.nextElement().split("=");

        		  if (data.length<2) continue;
        		  String type = data[0].trim();
        		  String def = data[1].trim();
        		  
        		  if (newtyp.equals(type)){
               		  JOptionPane.showMessageDialog(frame, "Вече има тип с това име");
            		  return;
        		  }
        		  if (newdef.equals(def)){
               		  JOptionPane.showMessageDialog(frame, "Този тип вече съществува: " + type);
            		  return;
        		  }
        	  }
              	  
        	  try {
				Writer out = new OutputStreamWriter(
							new FileOutputStream(typesfile,true), "UTF-8");
				
				out.write("\n"+newtype+"\n");
				out.flush();
				
				out.close();
				
				tmodel.addElement(newtype);
				
				
				
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
          }
      });

      examplebox.addListSelectionListener(new ListSelectionListener(){

		@Override
		public void valueChanged(ListSelectionEvent e) {
			// TODO Auto-generated method stub
			
        	  String exampletext = examplebox.getSelectedValue().toString();
        	  String exdat[] = exampletext.split(",");
        	  String example = exdat[0].trim();
        	  String origtype = exdat[1].trim();
        	  
        	  Enumeration<String> en = tmodel.elements();
        	  for (int i=0; i<tmodel.size(); i++){
//        	  while (en.hasMoreElements()){
        		  String l = tmodel.getElementAt(i);
//        		  String l = en.nextElement();
        		  String[] data = l.split("=");

        		  if (data.length<2) continue;
        		  String type = data[0].trim();
        		  
        		  if (type.equals(origtype)){
        			  selectedtypebox.setText(l);
        			  typebox.setSelectedIndex(i);
        		  }
        		  
        		  if (example.substring(0,5).contains("!"))
        			  other.setSelected(true);
        		  else
        			  other.setSelected(false);
        		  
        		  if (example.substring(0,5).contains("?"))
        			  fixed.setSelected(true);
        		  else
        			  fixed.setSelected(false);
        		  
        		  if (example.substring(0,5).contains("!"))
        			  other.setSelected(true);
        		  else
        			  other.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("!"))
        			  other.setSelected(true);
        		  else
        			  other.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("%"))
        			  vorder.setSelected(true);
        		  else
        			  vorder.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("^"))
        			  vorderx.setSelected(true);
        		  else
        			  vorderx.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("@"))
        			  modif.setSelected(true);
        		  else
        			  modif.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("/"))
        			  modifx.setSelected(true);
        		  else
        			  modifx.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("|"))
        			  external.setSelected(true);
        		  else
        			  external.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("+"))
        			  aspect.setSelected(true);
        		  else
        			  aspect.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("£"))
        			  onlydef.setSelected(true);
        		  else
        			  onlydef.setSelected(false);
        		  
        		  
        		  if (example.substring(0,5).contains("$"))
        			  nodef.setSelected(true);
        		  else
        			  nodef.setSelected(false);
        		  
           		  
        		  if (example.substring(0,5).contains("~"))
        			  nosing.setSelected(true);
        		  else
        			 nosing.setSelected(false);
           		  
        		  if (example.substring(0,5).contains("#"))
        			  noplural.setSelected(true);
        		  else
        			 noplural.setSelected(false);
        		  
        		  if (example.substring(0,5).contains("&"))
        			 NE.setSelected(true);
        		  else
        			 NE.setSelected(false);
        		  
        		  if (example.substring(0,5).contains("*"))
        			  error.setSelected(true);
        		  else
        			 error.setSelected(false);
        		  
        	  }
        	  
        	  /**
        	  
     JCheckBox aspect = new JCheckBox("Другият вид е валиден +");
      JCheckBox external = new JCheckBox("Външни |");
       JCheckBox modifx = new JCheckBox("XP модификатор /");
     JCheckBox modif = new JCheckBox("NP модификатор @");
     JCheckBox vorderx = new JCheckBox("Само XP_V ^");
       JCheckBox vorder = new JCheckBox("Само V_XP %");
      JCheckBox fixed = new JCheckBox("_XP неизм. ?");
     JCheckBox onlydef = new JCheckBox("Само чл. £");
     JCheckBox nodef = new JCheckBox("Само нечл. $");
    JCheckBox nosing = new JCheckBox("Само мн.ч. ~");
     JCheckBox noplural = new JCheckBox("Само ед.ч. #");
     JCheckBox NE = new JCheckBox("Именувана същност &");
     JCheckBox error = new JCheckBox("Невалидна единица *");

        	   */
	       	  String type = selectedtypebox.getText();

        	  FlectionModel fm = new FlectionModel(type);
        	  ArrayList<Form> forms = fm.generateForms(example);
        	  
        	  String formstext = "";
        	  for (Form f : forms) 
        		  formstext += 
        			  f.form +"," +f.POS+f.tags+ "\n";
        	  formsbox.setText(formstext);

		}
    	  
      });
     
      other.addItemListener(new ItemListener(){

    	  String symb = "!";
		@Override
		public void itemStateChanged(ItemEvent e) {
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });
      
 
       error.addItemListener(new ItemListener(){

    	  String symb = "*";
		@Override
		public void itemStateChanged(ItemEvent e) {
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });
      
      
       NE.addItemListener(new ItemListener(){

    	  String symb = "&";
		@Override
		public void itemStateChanged(ItemEvent e) {
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });
       noplural.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "#";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      nosing.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "~";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      nodef.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "$";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      onlydef.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "£";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });
      
      fixed.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "?";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

       vorder.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "%";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

       vorderx.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "^";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

       modif.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "@";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      modifx.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "/";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      external.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "|";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;
	        	  
	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });

      aspect.addItemListener(new ItemListener(){

		@Override
		public void itemStateChanged(ItemEvent e) {
			
			String symb = "+";
			// TODO Auto-generated method stub
			if (e.getStateChange() == ItemEvent.SELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  String newvalue = exampletext;
	        	  if (!newvalue.contains(symb))
	        		  newvalue = symb + exampletext;

	        	  int ind = examplebox.getSelectedIndex();
	        	  emodel.insertElementAt(newvalue, ind);
	        	  emodel.remove(ind+1);

			}
			
			if (e.getStateChange() == ItemEvent.DESELECTED){
				
	        	  String exampletext = examplebox.getSelectedValue().toString();

	        	  if (exampletext.substring(0,5).contains(symb)){
		        	  String newvalue = exampletext
		        			  .substring(0,5).replace(symb, "")
		        			  + exampletext.substring(5);
		        	  
		        	  int ind = examplebox.getSelectedIndex();
		        	  emodel.insertElementAt(newvalue, ind);
		        	  emodel.remove(ind+1);
	        	  }

			}
			
		}
    	  
      });


      JPanel labelexPanel = new JPanel();
      labelexPanel.add(button);
      labelexPanel.add(error);
      labelexPanel.add(NE);
      labelexPanel.add(other);
     
      JPanel labelexPanel1 = new JPanel();
      labelexPanel1.add(noplural);
      labelexPanel1.add(nosing);
      labelexPanel1.add(nodef);
      labelexPanel1.add(onlydef);

      JPanel labelexPanel2 = new JPanel();
      labelexPanel2.add(fixed);
      labelexPanel2.add(modif);
      labelexPanel2.add(modifx);
      
      
      JPanel labelexPanel3 = new JPanel();
      labelexPanel3.add(vorder);
      labelexPanel3.add(vorderx);
      labelexPanel3.add(external);
      labelexPanel3.add(aspect);
           
      JPanel labelexPanel4 = new JPanel();
      labelexPanel4.add(scroll_FB);
      labelexPanel4.add(scroll_FB1);


      container.add(typePanel);
      container.add(exPanel);
      container.add(labelexPanel);
      container.add(labelexPanel1);
      container.add(labelexPanel2);
      container.add(labelexPanel3);

      container.add(labelexPanel4);
      
//      container.add(scroll_FB);
      container.add(savebutton);

      frame.setSize(700,700);
      frame.setVisible(true);

  }

    public JMenuBar setupMenu(){
    	JMenuBar menu = new JMenuBar();
 
       	JMenu fileMenu = new JMenu("Файл");
       	fileMenu.setMnemonic(KeyEvent.VK_F);
       	String[] fileItems = new String[] {"Зареди типове",
       			"Отвори нов файл","Запази промените"
       			, "Запази с формите","Излез"};
       	char[] fileShortcuts = new char[] {'N','O', 'S', 'F','X'};
 
        	    	
       	JMenu helpMenu = new JMenu("Помощ");
       	helpMenu.setMnemonic(KeyEvent.VK_H);
       	String[] helpItems = new String[] {"Информация","Ръководство"};
       	char[] helpShortcuts = new char[] {'A','M'};
       	
      
       	ActionListener exitListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			exit();
       		}
       	};
       	
       	ActionListener newListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			openNewTypes();
      		}
       	};

       	ActionListener openListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			openNew();
      		}
       	};
       	

       	ActionListener saveListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			saveAll();
      		}
       	};


       	ActionListener saveFormsListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			saveAllForms();
      		}
       	};


       	ActionListener findListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			String word = (String)JOptionPane.showInputDialog(
                        frame,
                        "Find: ",
                        "Find dialog",
                        JOptionPane.PLAIN_MESSAGE,
                        null,
                        null,
                        "");

       			
        	}
       	};

       	ActionListener replaceListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
        	  JTextField xField = new JTextField(5);
       	      JTextField yField = new JTextField(5);

       	      JPanel myPanel = new JPanel();
       	      myPanel.add(new JLabel("Намери:"));
       	      myPanel.add(xField);
       	      myPanel.add(Box.createHorizontalStrut(15)); // a spacer
       	      myPanel.add(new JLabel("Замени с:"));
       	      myPanel.add(yField);

       	      int result = JOptionPane.showConfirmDialog(null, myPanel, 
       	               "Find and replace", JOptionPane.OK_CANCEL_OPTION);
  

       			
       			
        	}
       	};

       	ActionListener closeListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
    			int n = JOptionPane.showConfirmDialog(
    				    frame,
    				    "Запазихте ли промените?! Искате ли да продължите?",
    				    "Запазихте ли промените",
    				    JOptionPane.YES_NO_OPTION);
			
    		if (n==0){

       			

    		} else {
    			System.out.println("Close file cancelled ");
				
			}
        	}
       	};

       	
       	ActionListener manualListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			
       			JPanel panel = new JPanel();
       			
        		}
       	};

       	ActionListener aboutListener = new ActionListener(){
       		public void actionPerformed(ActionEvent e){
       			JOptionPane.showMessageDialog(frame,
       				    "<html>InflectionGenerator 1.0<br>Секция по компютърна лингвистика &copy; 2014-2019</html>",
       				    "Информация",
       				    JOptionPane.PLAIN_MESSAGE);
       		}
       	};
       	
      	ActionListener[] fileListeners = new ActionListener[] {
       			newListener, openListener, saveListener, 
       			saveFormsListener, exitListener};

       	
       	for (int i=0; i< fileItems.length; i++){
    		JMenuItem item = new JMenuItem(fileItems[i],fileShortcuts[i]);
    		item.addActionListener(fileListeners[i]);
    		fileMenu.add(item);
    		
    		if (fileItems[i].equals("Отвори")) fileMenu.addSeparator();
    		if (fileItems[i].equals("Запази и отвори")) fileMenu.addSeparator();
      	}

       	
       	JMenu submenu = new JMenu("Възстанови последния запазен вариант");
       	submenu.setMnemonic(KeyEvent.VK_S);


       	menu.add(fileMenu);
       	menu.add(helpMenu);

      	menu.add(helpMenu);

     	menu.add(new JSeparator(SwingConstants.VERTICAL));

     	/**
      	JButton checkspellingbutton = new JButton();
      	menu.add(checkspellingbutton);
      	
      	JLabel l = new JLabel("<html><font color='blue' size='5'> ?</font></html>");
		l.addMouseListener(new MouseListener(){
			
			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
				JOptionPane.showMessageDialog(
						frame, " ");
			}

			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
			}

			@Override
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			
		});

      	menu.add(l);
      	*/

      	menu.add(new JSeparator(SwingConstants.VERTICAL));


		return menu;
 
	}
    
    String currentDir = "";
    public void openNew(){
    	
 		JFileChooser chooser = new JFileChooser(
				currentDir);
 		
		
		 FileNameExtensionFilter filter = 
				 new FileNameExtensionFilter(
			        "Text files", "txt", "csv", "tsv");
		 chooser.setFileFilter(filter);
			    
		int option = chooser.showOpenDialog(frame);
		
		if (option == JFileChooser.APPROVE_OPTION) {
			File f = chooser.getSelectedFile();
 			
			exit();
			
			
			setup(typesfile,f.getAbsolutePath());
			currentDir = f.getParent();
			exfile = f.getAbsolutePath();
			
 
			
		}

    }

    public void openNewTypes(){
    	
 		JFileChooser chooser = new JFileChooser(
				currentDir);
 		
		
		 FileNameExtensionFilter filter = 
				 new FileNameExtensionFilter(
			        "Text files", "txt", "csv", "tsv");
		 chooser.setFileFilter(filter);
			    
		int option = chooser.showOpenDialog(frame);
		
		if (option == JFileChooser.APPROVE_OPTION) {
			File f = chooser.getSelectedFile();
 			
			exit();
			
			typesfile = f.getAbsolutePath();
			setup(typesfile,exfile);
			currentDir = f.getParent();
			
			
 
			
		}

    }

    
    /**
     * opens a confirm dialog before closing
     * 
     */
    void exit()
    {
            // confirm dialog
            int confirmed = JOptionPane.showConfirmDialog(frame,
                    "Close current file?", "Confirm exit",
                    JOptionPane.YES_NO_OPTION);
           
            if (confirmed == JOptionPane.YES_OPTION)
            {                            
                    frame.dispose();
                    
                    
            }
//            mainsugpanel.setVisible(false);
    }

    
    public void saveAll(){
  	  try {
		Writer out = new OutputStreamWriter(
					new FileOutputStream(exfile), "UTF-8");
		
		Enumeration<String> en = emodel.elements();
		while (en.hasMoreElements()){
			out.write(en.nextElement()+"\n");
			out.flush();
		}
		
		out.close();
		
		
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

    }
    
    
    public void saveAllForms(){
    	  try {
  		Writer out = new OutputStreamWriter(
  					new FileOutputStream(exfile+"_forms"), "UTF-8");
  		
  		Enumeration<String> en = emodel.elements();
  		while (en.hasMoreElements()){
  			
      	  String exampletext = en.nextElement();
      	  String exdat[] = exampletext.split(",");
      	  String example = exdat[0];
      	  String type = exdat[1];
      	  
      	  for (String t : typeslist){
      		  if (t.startsWith(type+"=")) type = t;
      	  }
      	  
      	  FlectionModel fm = new FlectionModel(type);
      	  ArrayList<Form> forms = fm.generateForms(example);
      	  
     	  System.out.println(forms.size());
      	  

     	 
      	  for (Form f : forms) {
      		 System.out.println(f.form +"," +f.POS+f.tags);
      		out.write(f.form +"," +f.POS+f.tags+ "\t"
      				+ exampletext+"\n");
  			out.flush();
      	  }
  		}
  		
  		out.close();
  		
  		
	  	} catch (Exception e1) {
	  		// TODO Auto-generated catch block
	  		e1.printStackTrace();
	  	}
    	  
    }

}

