package bg.bas.dcl.inflection.GUI;

import java.awt.Color;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import bg.bas.dcl.MWE.MWEComponent;

public class MWEComponentPanel extends JPanel {

	public MWEComponent mwe;
	
	public MWEComponentPanel (MWEComponent mwe){
		this.mwe = mwe;
		setup();
	}
	
	public void setup(){
		
		
		for (MWEComponent comp : mwe) {
			
			if (comp.size()==0) {
				
				continue;
			}
			
			JPanel comppanel = new MWEComponentPanel(comp);
			
			comppanel.add(new JLabel(comp.lemma + "\t"+comp.gram));
			
			comppanel.setBorder(BorderFactory.createLineBorder(Color.red));
			
//			JPanel featurePanel = new FeaturePanel(comp,new ArrayList<String>());
			
			this.add(comppanel);
			this.repaint();
		}
		
	}
	

}
