import java.io.File;

import org.json.simple.JSONObject;

import bg.bas.dcl.MWE.MWEProcessor;
import bg.bas.dcl.inflection.GUI.InflectionVerifierGUI;



public class InflectionVerifierInstance {
	
	
	public static void main(String[] args) {
		

		String initfile = "/home/ivelina/WORK-DCL/" +
				"INFLECTION/tool/gui-initparam.txt";
		
		String verblistfile = "/home/ivelina/WORK-DCL/" +
				"MWE-DICTS/MWE-Dictionary-1.0.xml";
		String noojdictfile = "/home/ivelina/WORK-DCL/" +
				"INFLECTION/noojdictverbflex.txt";
		
		String mwelistfile = "/home/ivelina/WORK-DCL/" +
				"MWE-DICTS/MWE_DICT_LREC/MWE-processed-list1.txt";
		String processedmwelistfile = "/home/ivelina/WORK-DCL/" +
				"MWE-DICTS/MWE_DICT_LREC/MWE-flexprocessed-list.txt";

		
		if (args.length > 0) initfile = args[0];
		
		MWEProcessor mp = new MWEProcessor(noojdictfile);
		InflectionVerifierGUI gui = new InflectionVerifierGUI(initfile);

		gui.setup();	
	
	}
}
