package bg.bas.dcl.inflection;

import java.util.ArrayList;

public class FormModel {
	
	public ArrayList<FormComponentModification> formModification =
			new ArrayList<FormComponentModification>();
	
	public String POS = "";
	public String tags = "";
	
	public String generateForm(String[] words){
		
		String result = "";
		
		int maxcomp = -1;

		for (FormComponentModification fcm : formModification){
//			int pos = word.length();
			
			if (fcm.componentID>maxcomp) maxcomp = fcm.componentID;
			
			if (fcm.componentID > 0 ) 
				result += fcm.generateFormComponent(words[fcm.componentID-1])+" ";
			
		}
		
		for (int i = maxcomp; i<words.length; i++) result += words[i] + " ";
		
		System.out.println("FORM: " + result);
		return result.trim();
	}
	
	
	
}
