package bg.bas.dcl.inflection.GUI;

import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class FeaturePanel extends JPanel {
	
	public Feature feature;
	public ArrayList<String> selected;
	
	public FeaturePanel(Feature feature, ArrayList<String> selected){
		
		this.feature = feature;
		this.selected = selected;
		setup();
		
	}
	
	public void setup(){
		
		JLabel label = new JLabel(feature.name);
		add(label);
		
		String sel = "";
		int selin = -1;
		
		if (selected.size()>0) sel = selected.get(0);
		
		if (feature.type.equals("single")) {
			JComboBox menu = new JComboBox();
			for (int i=0; i<feature.values.size(); i++) {
				String val = feature.values.get(i);
				menu.addItem(val);
				if (!sel.equals("") && val.equals(sel)) selin = i;
			}
			menu.setSelectedItem(selin);
			add(menu);
			
		} else {
			JComboBox menu = new JComboBox();
			for (int i=0; i<feature.values.size(); i++) {
				String val = feature.values.get(i);
				menu.addItem(val);
				if (!sel.equals("") && val.equals(sel)) selin = i;
			}
			menu.setSelectedItem(selin);
			add(menu);

		}
		
	}

}
