package bg.bas.dcl.inflection.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.Border;

import bg.bas.dcl.MWE.MWEComponent;

public class MWEPanel extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public MWEComponent mwe;
	
	public MWEPanel (MWEComponent mwe){

		this.mwe = mwe;
		setup();
	}
	
	public void setup(){
		
		for (MWEComponent comp : mwe) {
			
			JPanel comppanel = new MWEComponentPanel(comp);
			
			comppanel.add(new JLabel(comp.lemma + "\t"+comp.gram));
			
			comppanel.setBorder(BorderFactory.createLineBorder(Color.black));
			
			this.add(comppanel);
		}
		
		String forms = "";//mwe.generateForms();
        JTextArea textArea = new JTextArea(forms); 
//      textArea.setSize(400, 700);
      textArea.setLineWrap(true);
      textArea.setWrapStyleWord(true);
      textArea.setName("TEXTAREA");
      textArea.setEditable(false);
      textArea.setRows(40);
      textArea.setColumns(40);
      textArea.setBackground(Color.WHITE);
      JScrollPane scroll_TA = new JScrollPane (textArea);

      this.add(scroll_TA);
		
		this.repaint();

		
	}
	

}
